/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _CONTAINERS_PUBLIC_H_
#define _CONTAINERS_PUBLIC_H_

#include "cfg.h"
#include "htbuffer.h"

struct class_descriptor_s {
  char *name;
  int (*init_function)(cfgl_t *cfg, void **handle);
  int (*destroy_function)(void *handle);
  int (*work_setup_function)(void *handle, void **work_handle);
  int (*work_function)(void *handle, void *work_handle, char *input, htbuffer_t *output);
  int (*work_destroy_function)(void *handle, void *work_handle);
};

typedef struct class_descriptor_s class_descriptor_t;



#endif /* _CONTAINERS_PUBLIC_H_ */
