/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



#ifndef _HTCACHE_H_
#define _HTCACHE_H_

#include <pthread.h>


typedef struct htcache_s {
  const char *file;
  int expiry;
  pthread_mutex_t *mutex;
} htcache_t;

htcache_t *htcache_init(const char *file, int expiry);
void htcache_destroy(htcache_t *handle);
void htcache_insert(htcache_t *handle, const char *key, const char *value, int value_size);
int htcache_lookup(htcache_t *handle, const char *key, char** value, int* value_size2);


#endif /* _HTCACHE_H_ */  

  
