/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _STATS_H_
#define _STATS_H_

#include "smmapd.h"
#include "count.h"
#include "cfg.h"


#define SMM_TYPE_NULL 0
#define SMM_TYPE_COUNTER 1
#define SMM_TYPE_GAUGE 2

#define STAT_COUNTER_MAGIC 0x27061972

typedef struct counterDef_s {
  unsigned int type;
  const char *name;
} counterDef_t;

typedef struct statCounter_s {
  unsigned int magic;
  count_t *counter;
} statCounter_t;

typedef struct statCounterEntry_s {
  const char *moduleName;
  counterDef_t *counterDefs;
  statCounter_t *statCounters;
} statCounterEntry_t;
  
counterDef_t *addOneCounterDef(counterDef_t *counterDef, unsigned int type, const char* name);
statCounter_t *initStatCounter(const char *moduleName, counterDef_t *counterDefs);
unsigned int getStatCounter(statCounter_t *statCounter, int cnt_idx);
void incStatCounter(statCounter_t *statCounter, int cnt_idx);
void decStatCounter(statCounter_t *statCounter, int cnt_idx);
void outputStats(int stdout_nice, int syslog_nice);
#endif /* _STATS_H_ */
