/*
    Copyright (C) 2004, Wolfgang Hottgenroth

    This file is part of smmapdfw.

    smmapdfw is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  

    smmapdfw is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details. 

    You should have received a copy of the GNU General Public License
    along with smmapdfw. If not, write to the Free Software Foundation, 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



#ifndef _SNMP_SUBAGENT_H_
#define _SNMP_SUBAGENT_H_

#include "config.h"
#include "count.h"
#include "cfg.h"


#if ENABLE_NETSNMP==1
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>


typedef struct registrationEntry_s {
  oid *nameOid;
  int nameOidLen;
  char *nameRegistrationName;
  oid *valueOid;
  int valueOidLen;
  char *valueRegistrationName;
  int type;
  count_t *counter;
  const char *moduleName;
  const char *name;
} registrationEntry_t;

void snmp_subagent_main(cfg_t *cfg);
#endif

#endif /* _SNMP_SUBAGENT_H_ */  

  
